package Agentes;
import java.util.HashMap;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.WakerBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;



public class Profesor extends Agent{

	
	protected void setup() {	
		this.addBehaviour(new WakerBehaviour(this, 2000) {
			protected void onWake() {
				System.out.println(getLocalName().toUpperCase() + ": Buenos días a todos! \n");
				// Despertar alumnos
				Behaviour bWaker = new LlamarAlumnos(myAgent, 1000);
				myAgent.addBehaviour(bWaker);
			}
		});
	}

	protected void takeDown() {
		super.takeDown();
	}
	
	
	public class LlamarAlumnos extends WakerBehaviour {
		HashMap<String, AID> agentes;

		public LlamarAlumnos(Agent agente, int tiempo) { 
			super(agente, tiempo); 
		}
		
		public void onStart() {
			System.out.println("PROFESOR: Hoy tenéis toda la clase para seguir con el trabajo escrito! \n");
		}
		
		protected void onWake() {
			encontrarAgentes();
			myAgent.addBehaviour(new LlamarAlumno1(myAgent));
			myAgent.addBehaviour(new LlamarAlumno2(myAgent));
		}
		private class LlamarAlumno1 extends Behaviour {
			boolean finished;
			public LlamarAlumno1(Agent agente) { super(agente); finished = false; }
			
			public void action() {
				enviarMensaje("Danel", "Danel, espero que hoy estés mas callado \n");
				finished = true;
			}
			
			public boolean done() {
				return finished;
			}

			
		}
		private class LlamarAlumno2 extends Behaviour {
			boolean finished;
			public LlamarAlumno2(Agent agente) { super(agente); finished = false; }
			
			public void action() {
				enviarMensaje("Danel", "Suficiente!");
				finished = true;
			}
			
			public boolean done() {
				doDelete();
				return finished;
			}

			
		}
		public void encontrarAgentes() {
			DFAgentDescription template = new DFAgentDescription();
	        ServiceDescription sd = new ServiceDescription();
	        sd.setType("Escuela");
	        template.addServices(sd);
			try {		
	          	DFAgentDescription[] encontrados = DFService.search(myAgent, template); 
	          	agentes = new HashMap<String, AID>(encontrados.length);
	            for (int i = 0; i < encontrados.length; ++i) {
	            	AID a = encontrados[i].getName();
		        	agentes.put(a.getLocalName(), a);
	            }
			} catch (FIPAException e) {
				e.printStackTrace();
			}
		}
		public void enviarMensaje(String agente, String contenido) {
			ACLMessage inform = new ACLMessage(ACLMessage.INFORM);
	        inform.addReceiver(agentes.get(agente));
	        inform.setContent(contenido);
	        inform.setConversationId("despertar" + agente);
	        myAgent.send(inform);
		}

	}

}


